# -*- coding: utf-8 -*-
# This code is copyrighted and all rights are reserved
# for full legalities see the LEGAL file
from gi.repository import GLib, Gtk
from accountmanager import am
from appdata import _

escape = GLib.markup_escape_text


class Purchases(Gtk.VBox):
    def __init__(self):
        Gtk.VBox.__init__(self)

        self.set_border_width(25)
        self.set_spacing(10)

        l = Gtk.Label()
        l.set_alignment(0, 0.5)
        markup = _("My Purchases:")
        l.set_markup('<big>%s</big>' % escape(markup))
        self.pack_start(l, False, False, 0)

        l = Gtk.Label()
        l.set_alignment(0, 0.5)
        l.set_line_wrap(True)
        markup = _("To reinstall purchases you will need to use the Ubuntu "
                   "Software Center.")
        l.set_markup('<small>%s</small>' % escape(markup))
        self.pack_end(l, False, False, 0)

        # apps
        sw = Gtk.ScrolledWindow()
        self.v = Gtk.VBox()
        self.v.set_spacing(5)
        sw.add_with_viewport(self.v)
        self.pack_start(sw, True, True, 0)

        req = am.get_subscriptions()

        def on_downloaded(widget, content):
            import json
            subs = json.loads(content or '[]')
            subs = [s for s in subs if s['purchase_price'] != '0.00']

            for sub in subs:
                h = Gtk.HBox()
                self.v.pack_start(h, False, False, 0)
                l = Gtk.Label()
                l.set_alignment(0, 0.5)
                l.set_markup('%s\n<small>%s</small>' % (
                    escape(sub['application']['name']),
                    escape(sub['purchase_date'].split(' ')[0])))
                h.pack_start(l, False, False, 0)

            if not subs:
                for child in self.get_children():
                    self.remove(child)
                l = Gtk.Label()
                m = '<small>(%s)</small>'
                l.set_markup(m % escape(_("no purchased apps")))
                self.pack_start(l, True, True, 0)

            self.show_all()

        req.connect('downloaded', on_downloaded)
        req.download()
        self.show_all()
